#!/usr/bin/env python
from os import *

data_list = ['real-sim','news20.binary','rcv1_test.binary']

bestC = {}
bestC[('real-sim','l2-svm')] = 1.0
bestC[('real-sim','l1-svm')] = 1.0
bestC[('real-sim','lr')] = 8.0
bestC[('news20.binary','l2-svm')] = 4.0
bestC[('news20.binary','l1-svm')] = 2.0
bestC[('news20.binary','lr')] = 64.0
bestC[('rcv1_test.binary','l2-svm')] = 0.5
bestC[('rcv1_test.binary','l1-svm')] = 1.0
bestC[('rcv1_test.binary','lr')] = 8.0
# The best parameter C selected by 5-fold cross-validation

eps = 1e-6

def compare(data):

	#TRONLR
	cmd ="./liblinear/train -s 6 -c %s -e %s data/%s.train data/%s.test > log/TRONLR_%s_Cbest"\
			%(bestC[(data,'lr')], eps, data, data, data)
	print cmd
	system(cmd)

	#CDLRPER (coordinate descent method for logistic regression) (with permutation)
	cmd ="./liblinear/train -s 7 -c %s -e %s data/%s.train data/%s.test > log/CDLRPER_%s_Cbest"\
			%(bestC[(data,'lr')], eps, data, data, data)
	print cmd
	system(cmd)


for data in data_list:
	compare(data)

