#!/usr/bin/env python
from os import *

data_list = ['real-sim','news20.binary','rcv1_test.binary']

C = 1
eps = 1e-6
# Usually, eps = 0.1 is enough for CD/CDPER. Here we use a very small eps, 
#so that the CD/CDPER solvers reach the maximum step 150.

def compare(data):

	#CD
	cmd ="./liblinear/train -s 0 -c %s -e %s data/%s.train data/%s.test > log/CD_%s_C1"\
			%(C, eps, data, data, data)
	print cmd
	system(cmd)

	#CDPER
	cmd ="./liblinear/train -s 1 -c %s -e %s data/%s.train data/%s.test > log/CDPER_%s_C1"\
			%(C, eps, data, data, data)
	print cmd
	system(cmd)

	#CMLS
	cmd ="./liblinear/train -s 3 -c %s -e %s data/%s.train data/%s.test > log/CMLS_%s_C1"\
			%(C, eps, data, data, data)
	print cmd
	system(cmd)

	#TRON
	cmd ="./liblinear/train -s 5 -c %s -e %s data/%s.train data/%s.test > log/TRON_%s_C1"\
			%(C, eps, data, data, data)
	print cmd
	system(cmd)

for data in data_list:
	compare(data)

