#!/usr/bin/env python
from os import *
bestC = {}
bestC[('real-sim','l2-svm')] = 1.0
bestC[('real-sim','l1-svm')] = 1.0
bestC[('real-sim','lr')] = 8.0
bestC[('news20.binary','l2-svm')] = 4.0
bestC[('news20.binary','l1-svm')] = 2.0
bestC[('news20.binary','lr')] = 64.0
bestC[('rcv1_test.binary','l2-svm')] = 0.5
bestC[('rcv1_test.binary','l1-svm')] = 1.0
bestC[('rcv1_test.binary','lr')] = 8.0
data_list = ['real-sim','news20.binary','rcv1_test.binary']
data_size = {'real-sim':57848, 'news20.binary':15997, 'rcv1_test.binary':541920}

eps = 1e-6
# Usually, eps = 0.1 is enough for CD/CDPER. Here we use a very small eps, 
#so that the CD/CDPER solvers reach the maximum step 150.

pegasos_pass = 500
# We run PEGASOS 500 * l iterations, where l is the number of instances.

def compare(data):

	#CDPER
	cmd ="./liblinear/train -s 1 -c %s -e %s data/%s.train data/%s.test > log/CDPER_%s_Cbest"\
			%(bestC[(data, 'l2-svm')], eps, data, data, data)
	print cmd
	system(cmd)

	#TRON
	cmd ="./liblinear/train -s 5 -c %s -e %s data/%s.train data/%s.test > log/TRON_%s_Cbest"\
			%(bestC[(data, 'l2-svm')], eps, data, data, data)
	print cmd
	system(cmd)

	#CMLS
	cmd ="./liblinear/train -s 3 -c %s -e %s data/%s.train data/%s.test > log/CMLS_%s_Cbest"\
			%(bestC[(data, 'l2-svm')], eps, data, data, data)
	print cmd
	system(cmd)

	#PEGASOS
	iter = pegasos_pass * data_size[data] 
	cmd ='./pegasos/pegasos -testFile data/%s.test -lambda %.20f -iter %s data/%s.train > log/PEGASOS_%s_Cbest'\
			%( data, 1/bestC[(data, 'l1-svm')]/data_size[data], iter, data, data)
	print cmd
	system(cmd)

	#TRONLR
	cmd ="./liblinear/train -s 6 -c %s -e %s data/%s.train data/%s.test > log/TRONLR_%s_CbestC"\
			%(bestC[(data,'lr')], eps, data, data, data)
	print cmd
	system(cmd)

for data in data_list:
	compare(data)
